*#### ANSI .t.    !!!!
#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "xbpdev.ch"


*---------------- Fonts nur einmal erzeugen - create fonts only once ------

#define HB_FONT_14Arial         1
#define HB_FONT_12Arial         2
#define HB_FONT_12TimesNewRoman 3
#define HB_FONT_20Arial         4
#define CRLF                    chr(13)+chr(10)

procedure main
local oHBPrinter

SET CHARSET TO ANSI

*    nur fr Tests - only for debugging
/*
#ifdef __WIN32__
   set alternate to log.txt
#else
   set alternate to log2.txt
#endif
set alternate on
*/

? "Test-rotate.EXE - Printertest"


oHBPrinter := MyHBPrinter():New():create()

if oHBPrinter:IsPrinterError()             // Fehler verhindern, avoid errors
   ?
   ? "Standarddrucker ist nicht verfgbar !"
   ? "Standardprinter is not ready !"
   ?
   ? "Status: ",oHBPrinter:printerStatus(),"=",cPrinterStatus(oHBPrinter:printerStatus())
   ?
   ?
   wait


else

   oHBPrinter:addFont("14.Arial")
   oHBPrinter:addFont("12.Helvetica")
   oHBPrinter:addFont("12.Times New Roman")
   oHBPrinter:addFont({"Arial",20,.f.,.f.})
   ?
   ? "Liste der Schriften - List of used fonts"
   aeval(oHBPrinter:aFontList,{| oFont| qout(oFont:compoundname,oFont:nominalPointSize) })
   ?
   ? "Aus Ihrem Programmheraus starten Sie nun den :PrintingDialog() , egal wie !"
   ? "From your program you start the :PrintingDialog() , any way is possible !"
   wait




   oHBPrinter:PrintingDialog()

endif







quit


return




*-----------------------------------------------------------------------------------------------------



CLASS  MyHBPrinter from HBPrinter

   EXPORTED:
      METHOD Print                 // Alle variablen Druckausgaben werden hier definiert, wenn ntig wird ein
                                   // Seitenwechsel durchgefhrt, der Seitenzhler erhht und ::PrintForm() aufgerufen.
                                   // all variable output is defined in this method. If necessary it will call
                                   // ::NewPage(), increase the PageNo and calls ::PrintForm()
      METHOD PrintForm             // Alle fixen Bestandteile einer Seite, egal ob unten oder oben werden hier definiert,
                                   // hier wird KEIN Seitenumbruch aufgerufen, denn der knnte unntig sein (1.Seite).
                                   // all fix output - don't care where on page - is defined in this method.
                                   // Never call ::NewPage() inside.
ENDCLASS




*-------------------------------------------------------------
* die folgenden Methoden anpassen - folowing methods has to be modified
*-------------------------------------------------------------
METHOD MyHBPrinter:PrintForm()        // Alle fixen Bestandteile einer Seite, egal ob unten oder oben werden hier definiert,
                                      // hier wird KEIN Seitenumbruch aufgerufen, denn der knnte unntig sein (1.Seite).
                                      // all fix output - don't care where on page - is defined in this method.
                                      // Never call ::NewPage() inside.
   local altFont


   ::HBPrinter:PrintForm()           // falls Vorgabeformulare bentigt werden - if you need previous forms
                                      // sonst kann es weggelassen werden       - otherwise its ok to igore it

   * in abgeleiteten Klasse - in derived classes

   altFont := ::SetFont(HB_FONT_14Arial)

   ::PrintText( 200,2800, "Seite:"+str(::nPageNo),,, "box" )  // Text fr alle Seiten - text for all pages

   ::SetFont(altFont)

return self

*-------------------------------------------------------------
METHOD MyHBPrinter:Print()            // Alle variablen Druckausgaben werden hier definiert, wenn ntig wird ein
                                      // Seitenwechsel durchgefhrt, der Seitenzhler erhht und ::PrintForm() aufgerufen.
                                      // all variable output is defined in this method. If necessary it will call
                                      // ::NewPage(), increase the PageNo and calls ::PrintForm()
   local  PosX, PosY, cTxt, nBarLen

   ::nPageNo := 1
   ::lFirstPageForm := .f.         // Formular 1. Seite noch nicht gedruckt - form 1. page not printed

   * Hier folgt ihr Code
   ::HBPrinter:Print()      // mglich, aber eigentlich unntig - it's possible, but I think useless

   * in abgeleiteten Klasse - in derived classes

   ::nFirstLine := 250
   PosX := 400
   PosY := 400
   nBarLen := 300

   ::SetFont(HB_FONT_12TimesNewRoman)

   ::PrintForm()      // erste Seite Formular drucken

   ::PrintLine(PosX-nBarLen,PosY,PosX+nBarLen,PosY)
   ::PrintLine(PosX,PosY-nBarLen,PosX,PosY+nBarLen)

   cTxt := "Text links"

   ::PrintText( PosX,PosY,cTxt,"L")
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"L", , , , 90 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"L", , , , 180 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"L", , , , 270 )

   PosX += nBarLen*2+50

   ::PrintLine(PosX-nBarLen,PosY,PosX+nBarLen,PosY)
   ::PrintLine(PosX,PosY-nBarLen,PosX,PosY+nBarLen)

   cTxt := "Text rechts"

   ::PrintText( PosX,PosY,cTxt,"R",nBarLen)
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"R",nBarLen , , , 90 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"R",nBarLen , , , 180 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"R",nBarLen , , , 270 )

   PosX += nBarLen*2+50

   ::PrintLine(PosX-nBarLen,PosY,PosX+nBarLen,PosY)
   ::PrintLine(PosX,PosY-nBarLen,PosX,PosY+nBarLen)

   cTxt := "Text rechts++"

   ::PrintText( PosX+nBarLen,PosY,cTxt,"R",nBarLen)
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY-nBarLen,cTxt,"R",nBarLen , , , 90 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX-nBarLen,PosY,cTxt,"R",nBarLen , , , 180 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY+nBarLen,cTxt,"R",nBarLen , , , 270 )

   PosX := 400
   PosY += nBarLen*2+50

   ::PrintLine(PosX-nBarLen,PosY,PosX+nBarLen,PosY)
   ::PrintLine(PosX,PosY-nBarLen,PosX,PosY+nBarLen)

   cTxt := "Text links"

   ::PrintText( PosX,PosY,cTxt,"L")
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"L", , , , 90 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"L", , , , 180 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"L", , , , 270 )

   PosX += nBarLen*2+50

   ::PrintLine(PosX-nBarLen,PosY,PosX+nBarLen,PosY)
   ::PrintLine(PosX,PosY-nBarLen,PosX,PosY+nBarLen)

   cTxt := "Text zentriert"

   ::PrintText( PosX,PosY,cTxt,"z",nBarLen)
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"z",nBarLen , , , 90 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"z",nBarLen , , , 180 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY,cTxt,"z",nBarLen , , , 270 )

   PosX += nBarLen*2+50

   ::PrintLine(PosX-nBarLen,PosY,PosX+nBarLen,PosY)
   ::PrintLine(PosX,PosY-nBarLen,PosX,PosY+nBarLen)

   cTxt := "Text center++"

   ::PrintText( PosX+nBarLen/2,PosY,cTxt,"z",nBarLen)
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY-nBarLen/2,cTxt,"z",nBarLen , , , 90 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX-nBarLen/2,PosY,cTxt,"z",nBarLen , , , 180 )
   //PrintText( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, nDrehen )
   ::PrintText( PosX,PosY+nBarLen/2,cTxt,"z",nBarLen , , , 270 )

   PosX := 400
   PosY += nBarLen*2+50

   //PrintMemo( nPosX, nPosY, cTxt, cAusrichtung, nMaxLen, cArt, nFarbe, cHochQuer, nMaxBis,nLineFeed )
   ::PrintMemo(PosX,PosY,"Info:  Text ber"+CRLF+" mehrere Zeilen, Horizontal linksbndig","L",,,,"H")
   ::PrintMemo(PosX,PosY,"Info:  Text ber"+CRLF+" mehrere Zeilen, 90 linksbndig","L",,,,"90")
   ::PrintMemo(PosX,PosY,"Info:  Text ber"+CRLF+" mehrere Zeilen, 180 linksbndig","L",,,,"180")
   ::PrintMemo(PosX,PosY,"Info:  Text ber"+CRLF+" mehrere Zeilen, 270 linksbndig","L",,,,"270")

   PosX += nBarLen*2+50

   ::PrintMemo(PosX,PosY,"Info:  Text ber"+CRLF+" mehrere Zeilen, 270 linksbndig","L",,,,"250")

return self





*--------------------- allgemeine Funktionen - einmalig im Programm --------------------------
*                      used functions, usefull for other Programms too



Function ErrBox(uText,cTitel)
   local cText,x,xMax
   DEFAULT cTitel TO "Fehlermeldung"
   do case
      case valtype(uText) = "A"
           cText := uText[1]
           xMax  := len(uText)
           for x := 2 to xMax
               cText += chr(13) + uText[x]
           next
      case valtype(uText) = "C"
           cText := uText
      otherwise
           cText := "ErrBox wurde mit falschem Parameter "+;
                    " uText  aufgerufen ! Type "+valtype(uText)+;
                    " statt C oder A"+chr(13)+;
                    "Bitte diesen Fehler melden."
   endcase
   MsgBox(cText,cTitel)
return NIL

*---------------------------------------------------------------------------
function ntrim( nVar )
return strTran(alltrim( str( nVar ) ),".",",")

